--- sumpixels.old.cpp	2013-10-14 08:28:48.000000000 -0700
+++ sumpixels.cpp	2013-10-15 22:28:41.000000000 -0700
@@ -217,6 +217,8 @@
 DEF_INTEGRAL_FUNC(8u32s, uchar, int, double)
 DEF_INTEGRAL_FUNC(8u32f, uchar, float, double)
 DEF_INTEGRAL_FUNC(8u64f, uchar, double, double)
+DEF_INTEGRAL_FUNC(16u64f, ushort, double, double)
+DEF_INTEGRAL_FUNC(16s64f, short, double, double)
 DEF_INTEGRAL_FUNC(32f, float, float, double)
 DEF_INTEGRAL_FUNC(32f64f, float, double, double)
 DEF_INTEGRAL_FUNC(64f, double, double, double)
@@ -307,6 +309,10 @@
         func = (IntegralFunc)integral_8u32f;
     else if( depth == CV_8U && sdepth == CV_64F )
         func = (IntegralFunc)integral_8u64f;
+    else if( depth == CV_16U && sdepth == CV_64F )
+        func = (IntegralFunc)integral_16u64f;
+    else if( depth == CV_16S && sdepth == CV_64F )
+        func = (IntegralFunc)integral_16s64f;
     else if( depth == CV_32F && sdepth == CV_32F )
         func = (IntegralFunc)integral_32f;
     else if( depth == CV_32F && sdepth == CV_64F )
